Index: lemon/bfs.h
===================================================================
--- lemon/bfs.h	(revision 305)
+++ lemon/bfs.h	(revision 220)
@@ -22,5 +22,5 @@
 ///\ingroup search
 ///\file
-///\brief BFS algorithm.
+///\brief Bfs algorithm.
 
 #include <lemon/list_graph.h>
@@ -29,7 +29,8 @@
 #include <lemon/error.h>
 #include <lemon/maps.h>
-#include <lemon/path.h>
 
 namespace lemon {
+
+
 
   ///Default traits class of Bfs class.
@@ -40,71 +41,71 @@
   struct BfsDefaultTraits
   {
-    ///The type of the digraph the algorithm runs on.
+    ///The digraph type the algorithm runs on.
     typedef GR Digraph;
-
-    ///\brief The type of the map that stores the predecessor
+    ///\brief The type of the map that stores the last
     ///arcs of the shortest paths.
     ///
-    ///The type of the map that stores the predecessor
+    ///The type of the map that stores the last
     ///arcs of the shortest paths.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<typename Digraph::Arc> PredMap;
+    ///
+    typedef typename Digraph::template NodeMap<typename GR::Arc> PredMap;
     ///Instantiates a PredMap.
 
-    ///This function instantiates a PredMap.
-    ///\param g is the digraph, to which we would like to define the
-    ///PredMap.
-    static PredMap *createPredMap(const Digraph &g)
-    {
-      return new PredMap(g);
-    }
-
+    ///This function instantiates a \ref PredMap.
+    ///\param G is the digraph, to which we would like to define the PredMap.
+    ///\todo The digraph alone may be insufficient to initialize
+    static PredMap *createPredMap(const GR &G)
+    {
+      return new PredMap(G);
+    }
     ///The type of the map that indicates which nodes are processed.
 
     ///The type of the map that indicates which nodes are processed.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///\todo named parameter to set this type, function to read and write.
     typedef NullMap<typename Digraph::Node,bool> ProcessedMap;
     ///Instantiates a ProcessedMap.
 
-    ///This function instantiates a ProcessedMap.
+    ///This function instantiates a \ref ProcessedMap.
     ///\param g is the digraph, to which
-    ///we would like to define the ProcessedMap
+    ///we would like to define the \ref ProcessedMap
 #ifdef DOXYGEN
-    static ProcessedMap *createProcessedMap(const Digraph &g)
+    static ProcessedMap *createProcessedMap(const GR &g)
 #else
-    static ProcessedMap *createProcessedMap(const Digraph &)
+    static ProcessedMap *createProcessedMap(const GR &)
 #endif
     {
       return new ProcessedMap();
     }
-
     ///The type of the map that indicates which nodes are reached.
 
     ///The type of the map that indicates which nodes are reached.
-    ///It must meet the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///\todo named parameter to set this type, function to read and write.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
     ///Instantiates a ReachedMap.
 
-    ///This function instantiates a ReachedMap.
-    ///\param g is the digraph, to which
-    ///we would like to define the ReachedMap.
-    static ReachedMap *createReachedMap(const Digraph &g)
-    {
-      return new ReachedMap(g);
-    }
-
-    ///The type of the map that stores the distances of the nodes.
-
-    ///The type of the map that stores the distances of the nodes.
+    ///This function instantiates a \ref ReachedMap.
+    ///\param G is the digraph, to which
+    ///we would like to define the \ref ReachedMap.
+    static ReachedMap *createReachedMap(const GR &G)
+    {
+      return new ReachedMap(G);
+    }
+    ///The type of the map that stores the dists of the nodes.
+
+    ///The type of the map that stores the dists of the nodes.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///
     typedef typename Digraph::template NodeMap<int> DistMap;
     ///Instantiates a DistMap.
 
-    ///This function instantiates a DistMap.
-    ///\param g is the digraph, to which we would like to define the
-    ///DistMap.
-    static DistMap *createDistMap(const Digraph &g)
-    {
-      return new DistMap(g);
+    ///This function instantiates a \ref DistMap.
+    ///\param G is the digraph, to which we would like to define
+    ///the \ref DistMap
+    static DistMap *createDistMap(const GR &G)
+    {
+      return new DistMap(G);
     }
   };
@@ -115,11 +116,7 @@
   ///This class provides an efficient implementation of the %BFS algorithm.
   ///
-  ///There is also a \ref bfs() "function-type interface" for the BFS
-  ///algorithm, which is convenient in the simplier cases and it can be
-  ///used easier.
-  ///
-  ///\tparam GR The type of the digraph the algorithm runs on.
-  ///The default value is \ref ListDigraph. The value of GR is not used
-  ///directly by \ref Bfs, it is only passed to \ref BfsDefaultTraits.
+  ///\tparam GR The digraph type the algorithm runs on. The default value is
+  ///\ref ListDigraph. The value of GR is not used directly by Bfs, it
+  ///is only passed to \ref BfsDefaultTraits.
   ///\tparam TR Traits class to set various data types used by the algorithm.
   ///The default traits class is
@@ -127,4 +124,5 @@
   ///See \ref BfsDefaultTraits for the documentation of
   ///a Bfs traits class.
+
 #ifdef DOXYGEN
   template <typename GR,
@@ -136,23 +134,30 @@
   class Bfs {
   public:
-
-    ///The type of the digraph the algorithm runs on.
+    /**
+     * \brief \ref Exception for uninitialized parameters.
+     *
+     * This error represents problems in the initialization
+     * of the parameters of the algorithms.
+     */
+    class UninitializedParameter : public lemon::UninitializedParameter {
+    public:
+      virtual const char* what() const throw() {
+        return "lemon::Bfs::UninitializedParameter";
+      }
+    };
+
+    typedef TR Traits;
+    ///The type of the underlying digraph.
     typedef typename TR::Digraph Digraph;
 
-    ///\brief The type of the map that stores the predecessor arcs of the
-    ///shortest paths.
+    ///\brief The type of the map that stores the last
+    ///arcs of the shortest paths.
     typedef typename TR::PredMap PredMap;
-    ///The type of the map that stores the distances of the nodes.
+    ///The type of the map indicating which nodes are reached.
+    typedef typename TR::ReachedMap ReachedMap;
+    ///The type of the map indicating which nodes are processed.
+    typedef typename TR::ProcessedMap ProcessedMap;
+    ///The type of the map that stores the dists of the nodes.
     typedef typename TR::DistMap DistMap;
-    ///The type of the map that indicates which nodes are reached.
-    typedef typename TR::ReachedMap ReachedMap;
-    ///The type of the map that indicates which nodes are processed.
-    typedef typename TR::ProcessedMap ProcessedMap;
-    ///The type of the paths.
-    typedef PredMapPath<Digraph, PredMap> Path;
-
-    ///The traits class.
-    typedef TR Traits;
-
   private:
 
@@ -162,21 +167,21 @@
     typedef typename Digraph::OutArcIt OutArcIt;
 
-    //Pointer to the underlying digraph.
+    /// Pointer to the underlying digraph.
     const Digraph *G;
-    //Pointer to the map of predecessor arcs.
+    ///Pointer to the map of predecessors arcs.
     PredMap *_pred;
-    //Indicates if _pred is locally allocated (true) or not.
+    ///Indicates if \ref _pred is locally allocated (\c true) or not.
     bool local_pred;
-    //Pointer to the map of distances.
+    ///Pointer to the map of distances.
     DistMap *_dist;
-    //Indicates if _dist is locally allocated (true) or not.
+    ///Indicates if \ref _dist is locally allocated (\c true) or not.
     bool local_dist;
-    //Pointer to the map of reached status of the nodes.
+    ///Pointer to the map of reached status of the nodes.
     ReachedMap *_reached;
-    //Indicates if _reached is locally allocated (true) or not.
+    ///Indicates if \ref _reached is locally allocated (\c true) or not.
     bool local_reached;
-    //Pointer to the map of processed status of the nodes.
+    ///Pointer to the map of processed status of the nodes.
     ProcessedMap *_processed;
-    //Indicates if _processed is locally allocated (true) or not.
+    ///Indicates if \ref _processed is locally allocated (\c true) or not.
     bool local_processed;
 
@@ -185,5 +190,7 @@
     int _curr_dist;
 
-    //Creates the maps if necessary.
+    ///Creates the maps if necessary.
+
+    ///\todo Better memory allocation (instead of new).
     void create_maps()
     {
@@ -219,96 +226,92 @@
 
     template <class T>
-    struct SetPredMapTraits : public Traits {
+    struct DefPredMapTraits : public Traits {
       typedef T PredMap;
       static PredMap *createPredMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "PredMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     ///\brief \ref named-templ-param "Named parameter" for setting
-    ///PredMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///PredMap type.
+    ///PredMap type
+    ///
+    ///\ref named-templ-param "Named parameter" for setting PredMap type
+    ///
     template <class T>
-    struct SetPredMap : public Bfs< Digraph, SetPredMapTraits<T> > {
-      typedef Bfs< Digraph, SetPredMapTraits<T> > Create;
+    struct DefPredMap : public Bfs< Digraph, DefPredMapTraits<T> > {
+      typedef Bfs< Digraph, DefPredMapTraits<T> > Create;
     };
 
     template <class T>
-    struct SetDistMapTraits : public Traits {
+    struct DefDistMapTraits : public Traits {
       typedef T DistMap;
       static DistMap *createDistMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "DistMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     ///\brief \ref named-templ-param "Named parameter" for setting
-    ///DistMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///DistMap type.
+    ///DistMap type
+    ///
+    ///\ref named-templ-param "Named parameter" for setting DistMap type
+    ///
     template <class T>
-    struct SetDistMap : public Bfs< Digraph, SetDistMapTraits<T> > {
-      typedef Bfs< Digraph, SetDistMapTraits<T> > Create;
+    struct DefDistMap : public Bfs< Digraph, DefDistMapTraits<T> > {
+      typedef Bfs< Digraph, DefDistMapTraits<T> > Create;
     };
 
     template <class T>
-    struct SetReachedMapTraits : public Traits {
+    struct DefReachedMapTraits : public Traits {
       typedef T ReachedMap;
       static ReachedMap *createReachedMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "ReachedMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     ///\brief \ref named-templ-param "Named parameter" for setting
-    ///ReachedMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///ReachedMap type.
+    ///ReachedMap type
+    ///
+    ///\ref named-templ-param "Named parameter" for setting ReachedMap type
+    ///
     template <class T>
-    struct SetReachedMap : public Bfs< Digraph, SetReachedMapTraits<T> > {
-      typedef Bfs< Digraph, SetReachedMapTraits<T> > Create;
+    struct DefReachedMap : public Bfs< Digraph, DefReachedMapTraits<T> > {
+      typedef Bfs< Digraph, DefReachedMapTraits<T> > Create;
     };
 
     template <class T>
-    struct SetProcessedMapTraits : public Traits {
+    struct DefProcessedMapTraits : public Traits {
       typedef T ProcessedMap;
       static ProcessedMap *createProcessedMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "ProcessedMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     ///\brief \ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type.
+    ///ProcessedMap type
+    ///
+    ///\ref named-templ-param "Named parameter" for setting ProcessedMap type
+    ///
     template <class T>
-    struct SetProcessedMap : public Bfs< Digraph, SetProcessedMapTraits<T> > {
-      typedef Bfs< Digraph, SetProcessedMapTraits<T> > Create;
-    };
-
-    struct SetStandardProcessedMapTraits : public Traits {
+    struct DefProcessedMap : public Bfs< Digraph, DefProcessedMapTraits<T> > {
+      typedef Bfs< Digraph, DefProcessedMapTraits<T> > Create;
+    };
+
+    struct DefDigraphProcessedMapTraits : public Traits {
       typedef typename Digraph::template NodeMap<bool> ProcessedMap;
-      static ProcessedMap *createProcessedMap(const Digraph &g)
+      static ProcessedMap *createProcessedMap(const Digraph &G)
       {
-        return new ProcessedMap(g);
-        return 0; // ignore warnings
-      }
-    };
-    ///\brief \ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type to be <tt>Digraph::NodeMap<bool></tt>.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type to be <tt>Digraph::NodeMap<bool></tt>.
+        return new ProcessedMap(G);
+      }
+    };
+    ///\brief \ref named-templ-param "Named parameter"
+    ///for setting the ProcessedMap type to be Digraph::NodeMap<bool>.
+    ///
+    ///\ref named-templ-param "Named parameter"
+    ///for setting the ProcessedMap type to be Digraph::NodeMap<bool>.
     ///If you don't set it explicitly, it will be automatically allocated.
-    struct SetStandardProcessedMap :
-      public Bfs< Digraph, SetStandardProcessedMapTraits > {
-      typedef Bfs< Digraph, SetStandardProcessedMapTraits > Create;
+    template <class T>
+    struct DefProcessedMapToBeDefaultMap :
+      public Bfs< Digraph, DefDigraphProcessedMapTraits> {
+      typedef Bfs< Digraph, DefDigraphProcessedMapTraits> Create;
     };
 
@@ -319,8 +322,8 @@
     ///Constructor.
 
-    ///Constructor.
-    ///\param g The digraph the algorithm runs on.
-    Bfs(const Digraph &g) :
-      G(&g),
+    ///\param _G the digraph the algorithm will run on.
+    ///
+    Bfs(const Digraph& _G) :
+      G(&_G),
       _pred(NULL), local_pred(false),
       _dist(NULL), local_dist(false),
@@ -338,7 +341,7 @@
     }
 
-    ///Sets the map that stores the predecessor arcs.
-
-    ///Sets the map that stores the predecessor arcs.
+    ///Sets the map storing the predecessor arcs.
+
+    ///Sets the map storing the predecessor arcs.
     ///If you don't use this function before calling \ref run(),
     ///it will allocate one. The destructor deallocates this
@@ -355,7 +358,7 @@
     }
 
-    ///Sets the map that indicates which nodes are reached.
-
-    ///Sets the map that indicates which nodes are reached.
+    ///Sets the map indicating the reached nodes.
+
+    ///Sets the map indicating the reached nodes.
     ///If you don't use this function before calling \ref run(),
     ///it will allocate one. The destructor deallocates this
@@ -372,7 +375,7 @@
     }
 
-    ///Sets the map that indicates which nodes are processed.
-
-    ///Sets the map that indicates which nodes are processed.
+    ///Sets the map indicating the processed nodes.
+
+    ///Sets the map indicating the processed nodes.
     ///If you don't use this function before calling \ref run(),
     ///it will allocate one. The destructor deallocates this
@@ -389,8 +392,7 @@
     }
 
-    ///Sets the map that stores the distances of the nodes.
-
-    ///Sets the map that stores the distances of the nodes calculated by
-    ///the algorithm.
+    ///Sets the map storing the distances calculated by the algorithm.
+
+    ///Sets the map storing the distances calculated by the algorithm.
     ///If you don't use this function before calling \ref run(),
     ///it will allocate one. The destructor deallocates this
@@ -408,19 +410,18 @@
 
   public:
-
     ///\name Execution control
     ///The simplest way to execute the algorithm is to use
-    ///one of the member functions called \ref lemon::Bfs::run() "run()".
+    ///one of the member functions called \c run(...).
     ///\n
-    ///If you need more control on the execution, first you must call
-    ///\ref lemon::Bfs::init() "init()", then you can add several source
-    ///nodes with \ref lemon::Bfs::addSource() "addSource()".
-    ///Finally \ref lemon::Bfs::start() "start()" will perform the
-    ///actual path computation.
+    ///If you need more control on the execution,
+    ///first you must call \ref init(), then you can add several source nodes
+    ///with \ref addSource().
+    ///Finally \ref start() will perform the actual path
+    ///computation.
 
     ///@{
 
-    ///Initializes the internal data structures.
-
+    ///\brief Initializes the internal data structures.
+    ///
     ///Initializes the internal data structures.
     ///
@@ -460,5 +461,5 @@
     ///\return The processed node.
     ///
-    ///\pre The queue must not be empty.
+    ///\warning The queue must not be empty!
     Node processNextNode()
     {
@@ -482,15 +483,14 @@
     ///Processes the next node.
 
-    ///Processes the next node and checks if the given target node
+    ///Processes the next node. And checks that the given target node
     ///is reached. If the target node is reachable from the processed
-    ///node, then the \c reach parameter will be set to \c true.
+    ///node then the reached parameter will be set true. The reached
+    ///parameter should be initially false.
     ///
     ///\param target The target node.
-    ///\retval reach Indicates if the target node is reached.
-    ///It should be initially \c false.
-    ///
+    ///\retval reach Indicates that the target node is reached.
     ///\return The processed node.
     ///
-    ///\pre The queue must not be empty.
+    ///\warning The queue must not be empty!
     Node processNextNode(Node target, bool& reach)
     {
@@ -515,17 +515,14 @@
     ///Processes the next node.
 
-    ///Processes the next node and checks if at least one of reached
-    ///nodes has \c true value in the \c nm node map. If one node
-    ///with \c true value is reachable from the processed node, then the
-    ///\c rnode parameter will be set to the first of such nodes.
-    ///
-    ///\param nm A \c bool (or convertible) node map that indicates the
-    ///possible targets.
+    ///Processes the next node. And checks that at least one of
+    ///reached node has true value in the \c nm node map. If one node
+    ///with true value is reachable from the processed node then the
+    ///rnode parameter will be set to the first of such nodes.
+    ///
+    ///\param nm The node map of possible targets.
     ///\retval rnode The reached target node.
-    ///It should be initially \c INVALID.
-    ///
     ///\return The processed node.
     ///
-    ///\pre The queue must not be empty.
+    ///\warning The queue must not be empty!
     template<class NM>
     Node processNextNode(const NM& nm, Node& rnode)
@@ -549,9 +546,11 @@
     }
 
-    ///The next node to be processed.
-
-    ///Returns the next node to be processed or \c INVALID if the queue
-    ///is empty.
-    Node nextNode() const
+    ///Next node to be processed.
+
+    ///Next node to be processed.
+    ///
+    ///\return The next node to be processed or INVALID if the queue is
+    /// empty.
+    Node nextNode()
     {
       return _queue_tail<_queue_head?_queue[_queue_tail]:INVALID;
@@ -559,14 +558,13 @@
 
     ///\brief Returns \c false if there are nodes
-    ///to be processed.
+    ///to be processed in the queue
     ///
     ///Returns \c false if there are nodes
-    ///to be processed in the queue.
-    bool emptyQueue() const { return _queue_tail==_queue_head; }
-
+    ///to be processed in the queue
+    bool emptyQueue() { return _queue_tail==_queue_head; }
     ///Returns the number of the nodes to be processed.
 
     ///Returns the number of the nodes to be processed in the queue.
-    int queueSize() const { return _queue_head-_queue_tail; }
+    int queueSize() { return _queue_head-_queue_tail; }
 
     ///Executes the algorithm.
@@ -574,50 +572,34 @@
     ///Executes the algorithm.
     ///
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
+    ///
     ///This method runs the %BFS algorithm from the root node(s)
-    ///in order to compute the shortest path to each node.
-    ///
+    ///in order to
+    ///compute the
+    ///shortest path to each node. The algorithm computes
+    ///- The shortest path tree.
+    ///- The distance of each node from the root(s).
+    void start()
+    {
+      while ( !emptyQueue() ) processNextNode();
+    }
+
+    ///Executes the algorithm until \c dest is reached.
+
+    ///Executes the algorithm until \c dest is reached.
+    ///
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
+    ///
+    ///This method runs the %BFS algorithm from the root node(s)
+    ///in order to compute the shortest path to \c dest.
     ///The algorithm computes
-    ///- the shortest path tree (forest),
-    ///- the distance of each node from the root(s).
-    ///
-    ///\pre init() must be called and at least one root node should be
-    ///added with addSource() before using this function.
-    ///
-    ///\note <tt>b.start()</tt> is just a shortcut of the following code.
-    ///\code
-    ///  while ( !b.emptyQueue() ) {
-    ///    b.processNextNode();
-    ///  }
-    ///\endcode
-    void start()
-    {
-      while ( !emptyQueue() ) processNextNode();
-    }
-
-    ///Executes the algorithm until the given target node is reached.
-
-    ///Executes the algorithm until the given target node is reached.
-    ///
-    ///This method runs the %BFS algorithm from the root node(s)
-    ///in order to compute the shortest path to \c t.
-    ///
-    ///The algorithm computes
-    ///- the shortest path to \c t,
-    ///- the distance of \c t from the root(s).
-    ///
-    ///\pre init() must be called and at least one root node should be
-    ///added with addSource() before using this function.
-    ///
-    ///\note <tt>b.start(t)</tt> is just a shortcut of the following code.
-    ///\code
-    ///  bool reach = false;
-    ///  while ( !b.emptyQueue() && !reach ) {
-    ///    b.processNextNode(t, reach);
-    ///  }
-    ///\endcode
-    void start(Node t)
+    ///- The shortest path to \c  dest.
+    ///- The distance of \c dest from the root(s).
+    void start(Node dest)
     {
       bool reach = false;
-      while ( !emptyQueue() && !reach ) processNextNode(t, reach);
+      while ( !emptyQueue() && !reach ) processNextNode(dest, reach);
     }
 
@@ -626,27 +608,15 @@
     ///Executes the algorithm until a condition is met.
     ///
-    ///This method runs the %BFS algorithm from the root node(s) in
-    ///order to compute the shortest path to a node \c v with
-    /// <tt>nm[v]</tt> true, if such a node can be found.
-    ///
-    ///\param nm A \c bool (or convertible) node map. The algorithm
-    ///will stop when it reaches a node \c v with <tt>nm[v]</tt> true.
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
+    ///
+    ///\param nm must be a bool (or convertible) node map. The
+    ///algorithm will stop when it reaches a node \c v with
+    /// <tt>nm[v]</tt> true.
     ///
     ///\return The reached node \c v with <tt>nm[v]</tt> true or
     ///\c INVALID if no such node was found.
-    ///
-    ///\pre init() must be called and at least one root node should be
-    ///added with addSource() before using this function.
-    ///
-    ///\note <tt>b.start(nm)</tt> is just a shortcut of the following code.
-    ///\code
-    ///  Node rnode = INVALID;
-    ///  while ( !b.emptyQueue() && rnode == INVALID ) {
-    ///    b.processNextNode(nm, rnode);
-    ///  }
-    ///  return rnode;
-    ///\endcode
-    template<class NodeBoolMap>
-    Node start(const NodeBoolMap &nm)
+    template<class NM>
+    Node start(const NM &nm)
     {
       Node rnode = INVALID;
@@ -657,14 +627,14 @@
     }
 
-    ///Runs the algorithm from the given source node.
-
-    ///This method runs the %BFS algorithm from node \c s
-    ///in order to compute the shortest path to each node.
-    ///
-    ///The algorithm computes
-    ///- the shortest path tree,
-    ///- the distance of each node from the root.
-    ///
-    ///\note <tt>b.run(s)</tt> is just a shortcut of the following code.
+    ///Runs %BFS algorithm from node \c s.
+
+    ///This method runs the %BFS algorithm from a root node \c s
+    ///in order to
+    ///compute the
+    ///shortest path to each node. The algorithm computes
+    ///- The shortest path tree.
+    ///- The distance of each node from the root.
+    ///
+    ///\note b.run(s) is just a shortcut of the following code.
     ///\code
     ///  b.init();
@@ -680,12 +650,10 @@
     ///Finds the shortest path between \c s and \c t.
 
-    ///This method runs the %BFS algorithm from node \c s
-    ///in order to compute the shortest path to node \c t
-    ///(it stops searching when \c t is processed).
-    ///
-    ///\return \c true if \c t is reachable form \c s.
-    ///
-    ///\note Apart from the return value, <tt>b.run(s,t)</tt> is just a
-    ///shortcut of the following code.
+    ///Finds the shortest path between \c s and \c t.
+    ///
+    ///\return The length of the shortest s---t path if there exists one,
+    ///0 otherwise.
+    ///\note Apart from the return value, b.run(s) is
+    ///just a shortcut of the following code.
     ///\code
     ///  b.init();
@@ -693,38 +661,9 @@
     ///  b.start(t);
     ///\endcode
-    bool run(Node s,Node t) {
+    int run(Node s,Node t) {
       init();
       addSource(s);
       start(t);
-      return reached(t);
-    }
-
-    ///Runs the algorithm to visit all nodes in the digraph.
-
-    ///This method runs the %BFS algorithm in order to
-    ///compute the shortest path to each node.
-    ///
-    ///The algorithm computes
-    ///- the shortest path tree (forest),
-    ///- the distance of each node from the root(s).
-    ///
-    ///\note <tt>b.run(s)</tt> is just a shortcut of the following code.
-    ///\code
-    ///  b.init();
-    ///  for (NodeIt n(gr); n != INVALID; ++n) {
-    ///    if (!b.reached(n)) {
-    ///      b.addSource(n);
-    ///      b.start();
-    ///    }
-    ///  }
-    ///\endcode
-    void run() {
-      init();
-      for (NodeIt n(*G); n != INVALID; ++n) {
-        if (!reached(n)) {
-          addSource(n);
-          start();
-        }
-      }
+      return reached(t) ? _curr_dist : 0;
     }
 
@@ -734,54 +673,51 @@
     ///The result of the %BFS algorithm can be obtained using these
     ///functions.\n
-    ///Either \ref lemon::Bfs::run() "run()" or \ref lemon::Bfs::start()
-    ///"start()" must be called before using them.
+    ///Before the use of these functions,
+    ///either run() or start() must be calleb.
 
     ///@{
 
-    ///The shortest path to a node.
-
-    ///Returns the shortest path to a node.
-    ///
-    ///\warning \c t should be reachable from the root(s).
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
-    ///using this function.
-    Path path(Node t) const { return Path(*G, *_pred, t); }
+    typedef PredMapPath<Digraph, PredMap> Path;
+
+    ///Gives back the shortest path.
+
+    ///Gives back the shortest path.
+    ///\pre The \c t should be reachable from the source.
+    Path path(Node t)
+    {
+      return Path(*G, *_pred, t);
+    }
 
     ///The distance of a node from the root(s).
 
     ///Returns the distance of a node from the root(s).
-    ///
-    ///\warning If node \c v is not reachable from the root(s), then
-    ///the return value of this function is undefined.
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
-    ///using this function.
+    ///\pre \ref run() must be called before using this function.
+    ///\warning If node \c v in unreachable from the root(s) the return value
+    ///of this function is undefined.
     int dist(Node v) const { return (*_dist)[v]; }
 
-    ///Returns the 'previous arc' of the shortest path tree for a node.
-
-    ///This function returns the 'previous arc' of the shortest path
-    ///tree for the node \c v, i.e. it returns the last arc of a
-    ///shortest path from the root(s) to \c v. It is \c INVALID if \c v
-    ///is not reachable from the root(s) or if \c v is a root.
-    ///
-    ///The shortest path tree used here is equal to the shortest path
-    ///tree used in \ref predNode().
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
-    ///using this function.
+    ///Returns the 'previous arc' of the shortest path tree.
+
+    ///For a node \c v it returns the 'previous arc'
+    ///of the shortest path tree,
+    ///i.e. it returns the last arc of a shortest path from the root(s) to \c
+    ///v. It is \ref INVALID
+    ///if \c v is unreachable from the root(s) or \c v is a root. The
+    ///shortest path tree used here is equal to the shortest path tree used in
+    ///\ref predNode().
+    ///\pre Either \ref run() or \ref start() must be called before using
+    ///this function.
     Arc predArc(Node v) const { return (*_pred)[v];}
 
-    ///Returns the 'previous node' of the shortest path tree for a node.
-
-    ///This function returns the 'previous node' of the shortest path
-    ///tree for the node \c v, i.e. it returns the last but one node
-    ///from a shortest path from the root(s) to \c v. It is \c INVALID
-    ///if \c v is not reachable from the root(s) or if \c v is a root.
-    ///
+    ///Returns the 'previous node' of the shortest path tree.
+
+    ///For a node \c v it returns the 'previous node'
+    ///of the shortest path tree,
+    ///i.e. it returns the last but one node from a shortest path from the
+    ///root(a) to \c /v.
+    ///It is INVALID if \c v is unreachable from the root(s) or
+    ///if \c v itself a root.
     ///The shortest path tree used here is equal to the shortest path
     ///tree used in \ref predArc().
-    ///
     ///\pre Either \ref run() or \ref start() must be called before
     ///using this function.
